/*
   Program:   SIMPLE.C
   Version:   1.0

   This is a very simple C program that sends HTML text to
   the web client to display via the CGI gateway.

   This program must be compiled and linked before it can
   be used.  The following commands will do this:

   $ CC SIMPLE
   $ LINK SIMPLE

*/

#include <stdio.h>
#include <unixlib.h>

main(int argc, char *argv[])
{

  /*  Write out the content-type header followed by a blank line.
      This should always be the first output line in your program. */

  printf("content-type: text/html\n\n");

  /*  Write out some text and CGI variables.  */

  printf("<TITLE>Simple C Test of CGI-Gateway</TITLE>\n");
  printf("<H1>Simple C Test of CGI-Gateway</H1>\n");

  printf("This is just some text.<p>\n");

  printf("<H3>Here's some info about your client:</H3>\n");
  printf("<PRE>\n");
  printf("Client Application:           %s\n",getenv("HTTP_USER_AGENT"));
  printf("Client Acceptable MIME types: %s\n",getenv("HTTP_ACCEPT"));
  printf("Client Address:               %s\n",getenv("REMOTE_ADDR"));
  printf("Client Port number:           %s\n",getenv("REMOTE_PORT"));
  printf("Client Request method:        %s\n",getenv("REQUEST_METHOD"));
  printf("Requested Script Name:        %s\n",getenv("SCRIPT_NAME"));
  printf("</PRE>\n");

  printf("<H3>Here's some info about the server/connection:</H3>\n");
  printf("<PRE>\n");
  printf("Executing username:           %s\n",getenv("USER"));
  printf("Server Application:           %s\n",getenv("SERVER_SOFTWARE"));
  printf("Server Protocol:              %s\n",getenv("SERVER_PROTOCOL"));
  printf("Server Name:                  %s\n",getenv("SERVER_NAME"));
  printf("Server Port:                  %s\n",getenv("SERVER_PORT"));
  printf("Gateway Interface Info:       %s\n",getenv("GATEWAY_INTERFACE"));
  printf("</PRE>\n");

  /*  Show the parameters passed to the program.  */

  printf("<H3>Here's the parameters passed to this program:</H3>\n");
  printf("<PRE>\n");
  printf("ARGV[1]:                      %s\n",argv[1]);
  printf("ARGV[2]:                      %s\n",argv[2]);
  printf("ARGV[3]:                      %s\n",argv[3]);
  printf("</PRE>\n");

}
