$!  Program:   SIMPLE.COM
$!  Version:   1.0
$!
$!  This is a very simple DCL procedure that sends HTML text to 
$!  the web client to display via the CGI gateway.
$!
$!  Web variables are defined as both DCL symbols and a logical names. 
$!  The code below demonstrates the use of each.
$!
$!
$!  Write out the content-type header followed by a blank line.
$!  This should always be the first output line in your program.
$!
$ write sys$output "content-type: text/html"
$ write sys$output ""
$!
$!  Write out some text and CGI variables.  Use DCL Symbols to access
$!  the CGI variables.
$!
$ write sys$output "<HTML><HEAD>"
$ write sys$output "<TITLE>Simple DCL Test of CGI-Gateway</TITLE>"
$ write sys$output "</HEAD><BODY>"
$ write sys$output "<H1>Simple DCL Test of CGI-Gateway</H1>"
$ write sys$output "This is just some text.<p>"
$ write sys$output "<H3>Here's some info about your client:</H3>"
$ write sys$output "<PRE>"
$ write sys$output "Client Application:           ''WWW_HTTP_USER_AGENT'"
$ write sys$output "Client Acceptable MIME types: ''WWW_HTTP_ACCEPT'"
$ write sys$output "Client Address:               ''WWW_REMOTE_ADDR'"
$ write sys$output "Client Port number:           ''WWW_REMOTE_PORT'"
$ write sys$output "Client Request method:        ''WWW_REQUEST_METHOD'"
$ write sys$output "Requested Script Name:        ''WWW_SCRIPT_NAME'"
$ write sys$output "</PRE>"
$ write sys$output "<H3>Here's some info about the server/connection:</H3>"
$ write sys$output "<PRE>"
$ write sys$output "Executing username:           ''f$getjpi("","username")'"
$ write sys$output "Current directory:            ''f$environment("default")'"
$ write sys$output "Server Application:           ''WWW_SERVER_SOFTWARE'"
$ write sys$output "Server Protocol:              ''WWW_SERVER_PROTOCOL'"
$ write sys$output "Server Name:                  ''WWW_SERVER_NAME'"
$ write sys$output "Server Port:                  ''WWW_SERVER_PORT'"
$ write sys$output "Gateway Interface Info:       ''WWW_GATEWAY_INTERFACE'"
$ write sys$output "</PRE>"
$!
$!  Show all of the variables.   Use logicals to access the CGI and form
$!  variables.
$!
$ write sys$output "<H3>Here's a listing of all of the variables:</H3>"
$ write sys$output "<PRE>"
$ form_fields = f$trnlnm("form_fields")
$ write sys$output "  ""FORM_FIELDS"" = ""''form_fields'"""
$ if form_fields .nes. ""
$ then
$   show log/table=www_variables form_*
$ endif
$ show log/table=www_variables *
$ write sys$output "</PRE>"
$!
$!  Show the parameters passed to the program.
$!
$ write sys$output "<H3>Here's the parameters passed to this program:</H3>"
$ write sys$output "<PRE>"
$ show sym p1
$ show sym p2
$ show sym p3
$ write sys$output "</PRE>"
$ write sys$output "</BODY></HTML>"
$!
$ exit
