#   Program:   SIMPLE2.PL
#   Version:   1.0

#   This is a very simple Perl script that uses the CGI Perl Library to 
#   send HTML text to the web client to display.

#   Several Perl environment variables are setup automatically for you to
#   use in your scripts.  These variables are displayed by this program. 
#   See below.

#   Load the CGI Perl Library

use CGI;

#   Create a CGI object.

$query = new CGI;

#   Write out the content-type header followed by a blank line.

print $query->header;

#   Write the HEAD section, including the title.

print $query->start_html("Simple Perl CGI Library Script Test of CGI-Gateway");

#   Write out some text.

print qq{<A HREF="/cgi-docs/cgi_docs.html">Click here for documentation on the CGI Perl Library</A>};
print "<H1>Simple Perl CGI Library Script Test of CGI-Gateway</H1>\n";
print "This is just some text.<p>\n";
print "<H3>Here's some info about your client:</H3>\n";
print "<PRE>\n";
print "Client Application:           $ENV{'HTTP_USER_AGENT'}\n";
print "Client Acceptable MIME types: $ENV{'HTTP_ACCEPT'}\n";
print "Client Address:               $ENV{'REMOTE_ADDR'}\n";
print "Client Port number:           $ENV{'REMOTE_PORT'}\n";
print "Client Request method:        $ENV{'REQUEST_METHOD'}\n";
print "Requested Script Name:        $ENV{'SCRIPT_NAME'}\n";
print "</PRE>\n";
print "<H3>Here's some info about the server/connection:</H3>\n";
print "<PRE>\n";
print "Executing username:           $ENV{'USER'}\n";
print "Current directory:            $ENV{'PATH'}\n";
print "Server Application:           $ENV{'SERVER_SOFTWARE'}\n";
print "Server Protocol:              $ENV{'SERVER_PROTOCOL'}\n";
print "Server Name:                  $ENV{'SERVER_NAME'}\n";
print "Server Port:                  $ENV{'SERVER_PORT'}\n";
print "Gateway Interface Info:       $ENV{'GATEWAY_INTERFACE'}\n";
print "</PRE>\n";

#  List out the variables that Perl is aware of.  This code will not print
#  all of the variables available to Perl due to restrictions in VMS Perl. 
#  For a complete listing of the variables, see the SIMPLE.COM program.

print "<H3>Here's a listing of some of the variables:</H3>\n";
print "VMS Perl won't return all of the environment variables using the\n";
print "each() function.  They are available explicitly, though (as shown\n";
print "above).  Refer to SIMPLE.COM for a complete listing.\n";
print "<PRE>\n";
while (($symbol,$value) = each %ENV) {
  print "$symbol = $value\n";
}
print "</PRE>\n";

#  Show the parameters passed to the program.

print "<H3>Here's the parameters passed to this program:</H3>\n";
print "<PRE>\n";
print "\$ARGV[0]:                      $ARGV[0]\n";
print "\$ARGV[1]:                      $ARGV[1]\n";
print "\$ARGV[2]:                      $ARGV[2]\n";
print "</PRE>\n";

#   Write the HTML and BODY end parts.

print $query->end_html;
