/*
  Program:   SIMPLE_FORM.C
  Version:   1.0

  This simple Perl script provides 2 functions:
    1) It will send form information to the WWW client.
    2) It will interpret the data coming back from the form.

  Generally, #1 would be performed by a stand-alone form file.  We
  combined it into this program to reduce the number of files
  generated by the CGISETUP command.

*/

#include stdio
#include unixlib
#include string

main(int argc, char *argv[]) {

  char formData[1024];
  char *formDataPtr,*formField,*fieldValue,*p;
  int echar;
  int i, equalPosition;

/*  Write out the content-type header followed by a blank line.  */

  printf("content-type: text/html\n\n");

/* Are we asking for the form or a response to the form? */

  if (!strcmp(getenv("FORM_FIELDS"),"")) {    /* # Display the form. */
    printf("<HTML><HEAD>\n");
    printf("<title>DCL fill out forms example - form</title>\n");
    printf("</HEAD>\n");
    printf("<BODY>\n");
    printf("<h1>DCL fill out forms example</h1>\n");
    printf("<hr>\n");
    printf("This form activates the simple_form.pl script to show the symbols\n");
    printf("created when processing a form POST.\n");
    printf("<form method=\"POST\" action=\"/cgi/~%s/simple_form.exe\">\n",getenv("USER"));
    printf("Name: <input name=\"name\" type=\"text\" size=40 maxlength=80><BR>\n");
    printf("Address: <input name=\"address\" type=text><BR>\n");
    printf("Phone: <input name=\"phone\" type=\"text\" size=10 maxlength=30><BR>\n");
    printf("Favorite color: <select name=\"favorite_color\">\n");
    printf("<option selected> blue\n");
    printf("<option> red\n");
    printf("<option> green\n");
    printf("<option> yellow\n");
    printf("</select>\n");
    printf("<dl>\n");
    printf("<dd> <input type=\"checkbox\" name=\"Nearsighted\">Nearsighted\n");
    printf("<dd> <input type=\"checkbox\" name=\"Righthanded\">Right handed\n");
    printf("<dd> <input type=\"checkbox\" name=\"reckless\">Reckless driver\n");
    printf("<dd> <input type=\"checkbox\" name=\"wreckless\">Wreckless driver\n");
    printf("</dl>\n");
    printf("<P>\n");
    printf("<input type=\"submit\" value=\"  Submit  \"> <input type=\"reset\" value=\"  Reset \">\n");
    printf("</form>\n");
    printf("<hr>\n");
    printf("</BODY></HTML>\n");
  
  } else {               /*  Handle the response for the form  */
  
    printf("<HTML><HEAD>\n");
    printf("<TITLE>DCL fill out forms example - response</TITLE>\n");
    printf("</HEAD>\n");
    printf("<BODY>\n");
    printf("<H1>DCL fill out forms example - response</H1>\n");
    printf("<H3>Here\'s the info you filled out:</H3>\n");

    /*  Read the form data from standard input   */

    gets(formData);
    printf("<H4>Here\'s the data as it was read from standard input:</H4>\n");
    printf("<PRE>\n");
    printf("%s\n",formData);

    /*  CGI defines that form fields be seperated by an ampersand (&) and words
        be seperated by a plus (+).  If the user types a plus, ampersand, or
        percent sign, it is replaced with a percent sign folled by the
        ASCII hexadecimal value of the character.  */

    formDataPtr = formData;
    while (formField = strtok(formDataPtr,"&")) {   /* split the fields based on & */
      equalPosition = strcspn(formField,"=");
      formField[equalPosition] = '\0';
      fieldValue = formField + equalPosition + 1;
      printf("%s = ",formField);
      for(p=fieldValue; *p; p++) {
        if (*p == '+') putchar(' ');   /* replace + with space */
        else if (*p == '%') {          /* replace %xx with ASCII xx */
          sscanf(++p,"%2x",&echar);
          putchar(echar);
          p++;
        }
        else putchar(*p);
      }
      printf("\n");
      formDataPtr = NULL;              /* required by strtok */
    }
    printf("</PRE>\n");

    /*  Show the parameters to the program    */

    printf("<H3>Here's the parameters passed to this program:</H3>\n");
    printf("<PRE>\n");
    printf("$ARGV[0]:                      %s\n",argv[0]);
    printf("$ARGV[1]:                      %s\n",argv[1]);
    printf("$ARGV[2]:                      %s\n",argv[2]);
    printf("$ARGV[3]:                      %s\n",argv[3]);
    printf("</PRE>\n");
    printf("</BODY></HTML>\n");
  
  }
}
