$!  Program:   SIMPLE_FORM.COM
$!  Version:   1.0
$!
$!  This simple DCL procedure provides 2 functions:
$!    1) It will send form information to the WWW client.
$!    2) It will interpret the data coming back from the form.
$!
$!  Generally, #1 would be performed by a stand-alone form file.  We
$!  combined it into this program to reduce the number of files
$!  generated by the CGISETUP command.
$!
$!
$!  Write out the content-type header followed by a blank line.
$!
$   write sys$output "content-type: text/html"
$   write sys$output ""
$!
$!  Are we asking for the form or a response to the form?
$!
$   if form_fields .eqs. ""
$   then                        ! Display the form.
$     username = f$edit(f$getjpi("","username"),"trim")
$     write sys$output "<HTML><HEAD>"
$     write sys$output "<title>DCL fill out forms example - form</title>"
$     write sys$output "</HEAD>"
$     write sys$output "<BODY>"
$     write sys$output "<h1>DCL fill out forms example</h1>"
$     write sys$output "<hr>"
$     write sys$output "This form activates the simple_form.com program to show the symbols"
$     write sys$output "created when processing a form POST."
$     write sys$output "<form method=""POST"" action=""/cgi/~''username'/simple_form.com"">"
$     write sys$output "Name: <input name=""name"" type=""text"" size=40 maxlength=80><BR>"
$     write sys$output "Address: <input name=""address"" type=text><BR>"
$     write sys$output "Phone: <input name=""phone"" type=""text"" size=10 maxlength=30><BR>"
$     write sys$output "Favorite color: <select name=""favorite_color"">"
$     write sys$output "<option selected> blue"
$     write sys$output "<option> red"
$     write sys$output "<option> green"
$     write sys$output "<option> yellow"
$     write sys$output "</select>"
$     write sys$output "<dl>"
$     write sys$output "<dd> <input type=""checkbox"" name=""Nearsighted"">Nearsighted"
$     write sys$output "<dd> <input type=""checkbox"" name=""Righthanded"">Right handed"
$     write sys$output "<dd> <input type=""checkbox"" name=""reckless"">Reckless driver"
$     write sys$output "<dd> <input type=""checkbox"" name=""wreckless"">Wreckless driver"
$     write sys$output "</dl>"
$     write sys$output "<P>"
$     write sys$output "<input type=""submit"" value=""  Submit  ""> <input type=""reset"" value=""  Reset "">"
$     write sys$output "</form>"
$     write sys$output "<hr>"
$     write sys$output "</BODY></HTML>"
$   else
$!
$!  Handle the response for the form  The form data is read from DCL symbols.
$!
$     write sys$output "<HTML><HEAD>"
$     write sys$output "<TITLE>DCL fill out forms example - response</TITLE>"
$     write sys$output "</HEAD>"
$     write sys$output "<BODY>"
$     write sys$output "<H1>DCL fill out forms example - response</H1>"
$     write sys$output "Here's the info you filled out:"
$     write sys$output "<PRE>"
$     i = 0
$     formDataLoop:
$       fieldName = f$element(i,",",form_fields)
$       if fieldName .eqs. "," then goto formDataLoopEnd
$       fieldValue = form_fld_'fieldName'
$       write sys$output fieldName + " = " + fieldValue
$       i = i + 1
$       goto formDataLoop
$     formDataLoopEnd:
$     write sys$output ""
$     write sys$output "Total Number of items: ''i'"
$     write sys$output "</PRE>"
$!
$!  Show the parameters to the program.
$!
$     write sys$output "<H3>Here's the parameters passed to this program:</H3>"
$     write sys$output "<PRE>"
$     show symbol p1
$     show symbol p2
$     show symbol p3
$     write sys$output "</PRE>"
$     write sys$output "</BODY></HTML>"
$   endif
$!
$   exit
