#  Program:  SIMPLE_FORM1.PL
#  Version:  1.0

#  This simple Perl script provides 2 functions:
#    1) It will send form information to the WWW client.
#    2) It will interpret the data coming back from the form.

#  Generally, #1 would be performed by a stand-alone form file.  We
#  combined it into this program to reduce the number of files
#  generated by the CGISETUP command.


#  Write out the content-type header followed by a blank line.

print "content-type: text/html\n\n";

#  Are we asking for the form or a response to the form?

if ($ENV{"FORM_FIELDS"} eq "") {    # Display the form.
  print "<HTML><HEAD>\n";
  print "<title>Perl Script fill out forms example - form</title>\n";
  print "</HEAD>\n";
  print "<BODY>\n";
  print "<h1>Perl Script fill out forms example</h1>\n";
  print "<hr>\n";
  print "This form activates the simple_form1.pl script to show the symbols\n";
  print "created when processing a form POST.\n";
  print "<form method=\"POST\" action=\"/cgi/~$ENV{'USER'}/simple_form1.pl\">\n";
  print "Name: <input name=\"name\" type=\"text\" size=40 maxlength=80><BR>\n";
  print "Address: <input name=\"address\" type=\"text\"><BR>\n";
  print "Phone: <input name=\"phone\" type=\"text\" size=10 maxlength=30><BR>\n";
  print "Favorite color: <select name=\"favorite_color\">\n";
  print "<option selected> blue\n";
  print "<option> red\n";
  print "<option> green\n";
  print "<option> yellow\n";
  print "</select>\n";
  print "<dl>\n";
  print "<dd> <input type=\"checkbox\" name=\"Nearsighted\">Nearsighted\n";
  print "<dd> <input type=\"checkbox\" name=\"Righthanded\">Right handed\n";
  print "<dd> <input type=\"checkbox\" name=\"reckless\">Reckless driver\n";
  print "<dd> <input type=\"checkbox\" name=\"wreckless\">Wreckless driver\n";
  print "</dl>\n";
  print "<P>\n";
  print "<input type=\"submit\" value=\"  Submit  \"> <input type=\"reset\" value=\"  Reset \">\n";
  print "</form>\n";
  print "<hr>\n";
  print "</BODY></HTML>\n";

} else {                  #  Handle the response for the form

  print "<HTML><HEAD>\n";
  print "<TITLE>Perl Script fill out forms example - response</TITLE>\n";
  print "</HEAD>\n";
  print "<BODY>\n";
  print "<H1>Perl Script fill out forms example - response</H1>\n";
  print "<H3>Here\'s the info you filled out:</H3>\n";

  #  Read the form data from STDIN.

  $formData = <STDIN>;
  print "<H4>Here\'s the data as it was read from STDIN:</H4>\n";
  print "<PRE>\n";
  print $formData,"\n";
  print "</PRE>\n";

  # CGI defines that form fields be seperated by an ampersand (&) and words
  # be seperated by a plus (+).  If the user types a plus, ampersand, or
  # percent sign, it is replaced with a percent sign followed by the
  # ASCII hexadecimal value of the character.

  print "<H4>Here\'s the \"processed\" fields:</H4>\n";
  print "<PRE>\n";
  @formFields = split(/\&/,$formData);     # Split up the fields based on &
  foreach $field (@formFields) {
    ($fieldName,$fieldValue) = ($field =~ /([^=]+)=(.*)/);
    $fieldValue =~ s/\+/ /g;                    # CGI values always have pluses in place of spaces
    $fieldValue =~ s/\%(\d\d)/chr(hex($1))/ge;  # convert %xx to actual character
    print $fieldName," = ",$fieldValue,"\n";
  }
  print "</PRE>\n";

  # Show the parameters to the program.

  print "<H3>Here's the parameters passed to this program:</H3>\n";
  print "<PRE>\n";
  print "\$ARGV[0]:                      $ARGV[0]\n";
  print "\$ARGV[1]:                      $ARGV[1]\n";
  print "\$ARGV[2]:                      $ARGV[2]\n";
  print "</PRE>\n";
  print "</BODY></HTML>\n";

}
