#  Program:  SIMPLE_FORM2.PL
#  Version:  1.0

#  This simple Perl script that uses the CGI.PM library to 
#  provide 2 functions:
#    1) It will send form information to the WWW client.
#    2) It will interpret the data coming back from the form.

#  Generally, #1 would be performed by a stand-alone form file.  We
#  combined it into this program to reduce the number of files
#  generated by the CGISETUP command.


#   Load the CGI Perl Library

use CGI;

#   Create a CGI object.

$query = new CGI;

#   Write out the content-type header followed by a blank line.

print $query->header;

#  Are we asking for the form or a response to the form?

if ($ENV{"FORM_FIELDS"} eq "") {    # Display the form.
  print $query->start_html("Perl CGI Library Script file out forms example");
  print "<h1>Perl CGI Library Script file out forms example</h1>\n";
  print "<hr>\n";
  print "This form activates the simple_form1.pl script to show the symbols\n";
  print "created when processing a form POST.\n";
  print $query->startform("POST","/cgi/~$ENV{'USER'}/simple_form2.pl");
  print "Name: ",$query->textfield("name","",40,80),"<BR>\n";
  print "Address: ",$query->textfield("address"),"<BR>\n";
  print "Phone: ",$query->textfield("phone","",10,30),"<BR>\n";
  print "Favorite color: ",$query->popup_menu("favorite_color",["blue","red","green","yellow"],"blue"),"\n";
  print "<dl>\n";
  print "<dd>",$query->checkbox("Nearsighted"),"\n";
  print "<dd>",$query->checkbox("Righthanded"),"\n";
  print "<dd>",$query->checkbox("reckless"),"\n";
  print "<dd>",$query->checkbox("wreckless"),"\n";
  print "</dl>\n";
  print "<P>\n";
  print $query->submit("submit","  Submit  ");
  print $query->reset("  Reset  ");
  print $query->endform();
  print "<hr>\n";
  print $query->end_html;

} else {                  #  Handle the response for the form

  print $query->start_html("Perl Script fill out forms example - response");
  print "<H1>Perl Script fill out forms example - response</H1>\n";
  print "<H3>Here\'s the info you filled out:</H3>\n";

  #  Read the form data from STDIN.

  print "<PRE>\n";
  printValue("name");
  printValue("address");
  printValue("phone");
  printValue("favorite_color");
  printValue("Nearsighted");
  printValue("Righthanded");
  printValue("reckless");
  printValue("wreckless");
  print "</PRE>\n";

  # Show the parameters to the program.

  print "<H3>Here's the parameters passed to this program:</H3>\n";
  print "<PRE>\n";
  print "\$ARGV[0]:                      $ARGV[0]\n";
  print "\$ARGV[1]:                      $ARGV[1]\n";
  print "\$ARGV[2]:                      $ARGV[2]\n";
  print "</PRE>\n";

  print $query->end_html;

}

sub printValue {
  if ($query->param($_[0])) {
    print $_[0]," = ",$query->param($_[0]),"\n";
  }
}
